package bmp11;

import java.rmi.RemoteException;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.Collection;

import javax.ejb.CreateException;
import javax.ejb.EJBException;
import javax.ejb.EntityBean;
import javax.ejb.EntityContext;
import javax.ejb.FinderException;
import javax.ejb.NoSuchEntityException;
import javax.ejb.RemoveException;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.sql.DataSource;

public class ManBean implements EntityBean{

	//SQL萔

	private static final String TABLE = "MAN";//"\"ManBeanTable\"";

	private static final String ID = "ID";//"\"id\"";
	
	private static final String NAME = "NAME";//"\"name\"";
	
	private static final String AGE = "AGE";//"\"age\"";

	private static final String DS_NAME = "java:comp/env/jdbc/SomeDS";




	private EntityContext context;


	//tB[h

	private String id;
	private String name;
	private int age;


	/**
	 * Ԃľ^͎L[NXCreateExceptionthrowKv܂B
	 * ܂Ԃl͎L[ԂKv܂B
	 */
	public String ejbCreate(String id) throws CreateException{
		
		System.out.println("ejbCreate : id=" + id);
		
		this.id = id;

		String sql = "INSERT INTO " + TABLE + "(" +ID+ ") VALUES(\"" +id+ "\")";
		
		executeUpdate(sql);
		
		return id;
	}

	/**
	 * ejbCreateƓ܂B
	 */
	public void ejbPostCreate(String id){

		System.out.println("ejbPostCreate : id=" + id);
	}


	//t@C_\bh

	public String ejbFindByPrimaryKey(String id) throws FinderException{

		System.out.println("ejbFindByPrimaryKey : id=" + id);

		Connection con = getConnection();
		
		try{

			String sql 
				= "SELECT * FROM " + TABLE 
				+ " WHERE " +ID+ "=\"" + id + "\""
				;
			
			ResultSet rs = executeQuerry(con, sql);
			
			if(rs.next()){
				name = rs.getString(NAME);
				age = rs.getInt(AGE);
			}else{
				throw new FinderException("id=" + id);				
			}

			return id;
			
		}catch(SQLException e){
			e.printStackTrace();
			throw new EJBException(e);
		}finally{
			releaseConnection(con);
		}
		

	}


	/**
	 * L[NX̃RNVԂ
	 */
	public Collection ejbFindUnderAge(int age) throws FinderException{

		System.out.println("ejbFindUnderAge : age=" + age);


		Connection con = getConnection();
		
		try{
			String sql 
				= "SELECT " +ID+ " FROM " + TABLE 
				+ " WHERE " +AGE+ "<" + age
				;
			
			ResultSet rs = executeQuerry(con, sql);
		
			Collection col = new ArrayList();
			
			while(rs.next()){
				col.add(rs.getString(ID));
			}
			
			return col;
			
		}catch(SQLException e){
			e.printStackTrace();
			throw new EJBException(e);
		}finally{
			releaseConnection(con);
		}		
	}



	//JANZT(EJB̃rWlX\bh)

	public int getAge() {
		return age;
	}

	public String getId() {
		return id;
	}

	public String getName() {
		return name;
	}

	public void setAge(int age) {
		this.age = age;
	}

//	public void setId(String id) {
//		this.id = id;
//	}

	public void setName(String name) {
		this.name = name;
	}

	
	
	
	//EntityBeanC^[tFCX

	public void ejbActivate() throws EJBException, RemoteException {

		System.out.println("ejbActivate");

		this.id = (String)context.getPrimaryKey();
	}

	public void ejbLoad() throws EJBException, RemoteException {

		System.out.println("ejbLoad");

		Connection con = getConnection();
		
		try{
			
			String sql 
				= "SELECT NAME,AGE FROM " + TABLE 
				+ " WHERE " +ID+ "=\"" + id + "\""
				;
			
			ResultSet rs = executeQuerry(con, sql);
			
			if(rs.next()){
				name = rs.getString(NAME);
				age = rs.getInt(AGE);
			}else{
				throw new NoSuchEntityException("id=" + id);				
			}

			
		}catch(SQLException e){
			e.printStackTrace();
			throw new EJBException(e);
		}finally{
			releaseConnection(con);
		}
		

	}

	public void ejbPassivate() throws EJBException, RemoteException {

		System.out.println("ejbPassivate");

		id = null;
	}

	public void ejbRemove() throws RemoveException, EJBException, RemoteException {
		
		System.out.println("ejbRemove");		
		
		String sql
			= "DELETE FROM "+TABLE
			+ " WHERE ID=\"" +id+ "\""
			;
		
		executeUpdate(sql);
	}


	public void ejbStore() throws EJBException, RemoteException {

		System.out.println("ejbStore");

		String sql 
			= "UPDATE " +TABLE
			+ " SET NAME=\"" + NAME + "\""
				+ ", AGE=" + age
			+ " WHERE ID = \"" + id + "\""
			;

		int row = executeUpdate(sql);
		if(row != 1){
			throw new EJBException("ejbStore failed");
		}

	}

	public void setEntityContext(EntityContext context) throws EJBException, RemoteException {

		System.out.println("setEntityContext");
			
		this.context = context;
	}

	public void unsetEntityContext() throws EJBException, RemoteException {

		System.out.println("unsetEntityContext");

		context = null;
	}




	private ResultSet executeQuerry(Connection con, String sql) throws SQLException{

		System.out.println("executeQuerry : sql=" + sql);

		Statement smt = con.createStatement();

		ResultSet rs = smt.executeQuery(sql);
		
		return rs;

	}


	private int executeUpdate(String sql){		

		System.out.println("executeUpdate : sql=" + sql);

		Connection con = getConnection();

		try{	
			Statement smt = con.createStatement();
			int row = smt.executeUpdate(sql);
			return row;
	
		}catch(Exception e){
			e.printStackTrace();
			throw new EJBException(e);
	
		}finally{
			releaseConnection(con);
		}
	}


	private Connection getConnection(){

		try{
			DataSource ds = getDataSource();
			return ds.getConnection();

		}catch(SQLException e){
			e.printStackTrace();
			throw new EJBException(e);
		}
		
	}

	private DataSource getDataSource(){

		try{
			InitialContext ctx = new InitialContext();
			return (DataSource)ctx.lookup(DS_NAME);
		}catch(NamingException e){
			e.printStackTrace();
			throw new EJBException(e);
		}

	}


	private void releaseConnection(Connection con){
		
		if(con != null){
			try{
				con.close();
			}catch(SQLException e){
				//łȂ
			}
		}
	}



}
